<?php

namespace Zeedhi\MessageApi\SMS;

class ManagerSMS {

    protected $url;
    protected $tokenApi;

    public function __construct($tokenApi, $url = 'https://sms.comtele.com.br/') {
        $this->url = $url;
        $this->tokenApi = $tokenApi;
    }

    public function getUrl() {
        return $this->url;
    }

    public function setUrl($url) {
        $this->url = $url;
    }

    public function getTokenApi() {
        return $this->tokenApi;
    }

    public function setTokenApi($tokenApi) {
        $this->tokenApi = $tokenApi;
    }

    public function sendSms($ddd, $PhoneNumber, $message) {
        $header = $this->buildHeader();
        $body = $this->buildBody($ddd, $PhoneNumber, $message);
        $curl = $this->initCurl(json_encode($body), $header);
        $curlResponse = curl_exec($curl);
        $httpCode = curl_getinfo($curl, CURLINFO_HTTP_CODE);
        $this->checkResponse($curl, $curlResponse, $httpCode);
        curl_close($curl);
        return json_decode($curlResponse, true);
    }

    private function buildHeader() {
        return [
            "auth-key: {$this->tokenApi}",
            "Content-Type: application/json"
        ];
    }

    private function buildBody($ddd, $PhoneNumber, $message) {
        return [
            "Receivers" => $ddd . $PhoneNumber,
            "Content"   => $message
        ];
    }

    private function initCurl($body, $header) {
        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => $this->url . '/api/v2/send',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 4,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_SSL_VERIFYPEER => false,
            CURLOPT_CUSTOMREQUEST => 'POST',
            CURLOPT_POSTFIELDS => $body,
            CURLOPT_HTTPHEADER => $header,
        ));
        return $curl;
    }

    private function checkResponse($curl, $curlResponse, $httpCode) {
        if (!empty(curl_error($curl)) || ($httpCode != 200) || (stripos($curlResponse, "<html>")) || (stripos($curlResponse, "Fatal error"))) {
            $error = curl_error($curl);
            $menssage = $curlResponse;
            $res = json_decode($curlResponse, true);
            if(!empty($res['Message'])) {
                $menssage = $res['Message'];
            }
            if(empty($menssage)) {
                $menssage = $error;
            }
            curl_close($curl);
            throw new \Exception('Error ao enviar o SMS: '. $menssage);
        }
    }
}