# SMS

Guia para utilizar a **API de SMS da Comtele** para enviar mensagens de texto. Siga as instruções abaixo para começar a enviar SMS de forma rápida e prática.

Para mais informações, visite:
- https://docs.comtele.com.br/
- https://sms.comtele.com.br/

## Token

A comunicação com o a **API da Comtele** requer um **token** de autenticação. Siga os passos abaixo para obtê-lo.

![Chave de API](/img/imgSMS/keyApi.jpg)

> <span style="color: red;">*Nota:*</span>  *Obtenha Sua Chave de API , como na imagem acima.*

1. Faça login no aplicativo da Comtele em **https://sms.comtele.com.br**.

2. No menu lateral, dentro da seção API, clique em "Chave de API".

3. Você será redirecionado para a página de Informações do Desenvolvedor, onde encontrará o campo denominado "**Sua Chave de API**". Esta chave deve ser incluída no cabeçalho das solicitações API no seguinte formato: **auth-key: XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX**.

## URL Base da API
- URL Base da API : **https://sms.comtele.com.br/api/v2/**

## Enviar SMS

Com este recurso, é possivel enviar SMS de forma instantânea.  Siga as instruções abaixo para enviar SMS:

- URL do Endpoint: **https://sms.comtele.com.br/api/v2/send**
- Autenticação via Header: **auth-key: XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX**
- Método: **POST**

> <span style="color: red;">*Nota:*</span>  *Para enviar SMS pela plataforma Comtele, é necessário possuir créditos disponíveis.*

> <span style="color: red;">*Nota:*</span>  *Nos casos que o conteúdo do SMS superar 160 caracteres, será tarifado mais de um crédito a cada 153 caracteres. Algumas operadoras como a Oi e Sercomtel não suportam concatenação da mensagens, então serão recebidos SMS separadamente.*

## Instalação via composer 

Adicione a biblioteca na sua aplicação com o comando abaixo:

```sh
composer require zeedhi/message-api
```

## Implementação

Foi implementada a classe **[\Zeedhi\MessageApi\SMS\ManagerSMS](src/SMS/ManagerSMS.php)** para facilitar o uso e disponibilizar funções úteis.

##### Exemplo de uso:

```php
<?php

// Substitua 'SEU_TOKEN_API' pelo seu token de autenticação
$tokenApi = 'SEU_TOKEN_API';

$smsManager = new \Zeedhi\MessageApi\SMS\ManagerSMS($tokenApi);

// Exemplo de envio de SMS
$ddd = 'XX'; // Código de área do número
$phoneNumber = 'XXXXXXXXX'; // Número do telefone de destino
$message = 'Exemplo de mensagem SMS';

$smsManager->sendSms($ddd, $phoneNumber, $message);

?>
```